WoWJapanizerWorldMapQuest = WoWJapanizerQuest:New("WoWJapanizerWorldMapQuestScroll")

function WoWJapanizerWorldMapQuest:OnInitialize()
    self:Initialize()

    self.selected = 0
    self.WorldMapQuestScrollFrameHeight = WorldMapQuestScrollFrame:GetHeight()

    WoWJapanizerWorldMapQuestShowJapaneseText:SetText("Show Japanese")
    WoWJapanizerWorldMapQuestShowJapanese:SetPoint("BOTTOMRIGHT", WorldMapTrackQuest, "BOTTOMRIGHT", WorldMapTrackQuestText:GetWidth() + 45, 0)
    self:SetChecked(WoWJapanizer.db.profile.quest.worldmap)

	hooksecurefunc("WorldMapFrame_SelectQuestFrame", function(questFrame)
        self.selected = questFrame.questId
        WoWJapanizerWorldMapQuest:QuestInfo(questFrame.questId)
    end)
end

function WoWJapanizerWorldMapQuest:OnEnable()
    WoWJapanizer:DebugLog("WoWJapanizerWorldMapQuest: OnEnable.");
end

function WoWJapanizerWorldMapQuest:OnDisable()
    WoWJapanizer:DebugLog("WoWJapanizerWorldMapQuest: OnDisable.");
end

function WoWJapanizerWorldMapQuest:ResizeWorldMapQuestScrollFrame()
    if WoWJapanizerWorldMapQuestShowJapanese:GetChecked() then
        local h = self.WorldMapQuestScrollFrameHeight - WorldMapQuestDetailScrollFrame:GetHeight() - 8
        WorldMapQuestScrollFrame:SetHeight(h)
    else
        WorldMapQuestScrollFrame:SetHeight(self.WorldMapQuestScrollFrameHeight)
    end
end

function WoWJapanizerWorldMapQuest:QuestInfo(questID)
    if not WoWJapanizerWorldMapQuestShowJapanese:GetChecked() then
        return
    end

    self:ShowDefault(questID)
end

function WoWJapanizerWorldMapQuest:OnClickShowJapanese()
    self:SetChecked(WoWJapanizerWorldMapQuestShowJapanese:GetChecked())
    if WoWJapanizerWorldMapQuestShowJapanese:GetChecked() then
        self:QuestInfo(self.selected)
    end
end

function WoWJapanizerWorldMapQuest:SetChecked(check)
    WoWJapanizerWorldMapQuestShowJapanese:SetChecked(check)
    if not WoWJapanizerWorldMapQuestShowJapanese:GetChecked() then
        self.Frame:Hide()
    end
    self:ResizeWorldMapQuestScrollFrame()
end
